//
// Horizontal Scroll Test Code
//

#include "stdafx.h"

#include <DDraw.h>
#include <ISTBTDDExt.h>

#include "tulsa sample app.h"
#include "mainfrm.h"
#include "CardDlg.h"
#include "InitCardDlg.h"
#include "dibapi.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#undef TEST_ABS_NOTIF

#define TEXT_HEIGHT_HS		40
#define TEXT_SPACE_HS		150

#define SRC_WIDTH_HS		1200
#define UPDATE_SIZE_HS		SRC_WIDTH_HS/3


//temp
BOOL bColor = TRUE;

void DrawOverlayHorz(int &Count, int DrawOffset, int BufferOffset, int Size,
	LPDIRECTDRAWSURFACE lpDDS, int height)
{
	int x, y;
	DDSURFACEDESC SurfaceDesc;

	DWORD AlphaValue = 0x80000000;

	if (lpDDS->Lock(NULL, &SurfaceDesc, 0, NULL) == DD_OK) {

		CDC DC; 
		DC.Attach(GetDC(NULL));

		DWORD width = Size;			
		DWORD Stride = SurfaceDesc.lPitch;
		DWORD BytesPerPixel = SurfaceDesc.ddpfPixelFormat.dwRGBBitCount/8;	// only 16 & 32 supported
		LPVOID lpSurface = SurfaceDesc.lpSurface;

		CRect rect = CRect(0, 0, width , height);
		CBitmap Bmp;
		if (Bmp.CreateCompatibleBitmap(&DC, width, height)) {

			CDC MemDC;
			if (MemDC.CreateCompatibleDC(&DC)) {
				CBitmap* pBmpOld = MemDC.SelectObject(&Bmp);

				COLORREF BrushColor;
				if (bColor) {
					BrushColor = RGB(255, 255, 255);
				} else {
					bColor = TRUE;
					BrushColor = RGB(80, 80, 80);
				}
				CBrush brush(BrushColor);
				MemDC.FillRect(&rect, &brush);
				CBrush *pBrushOld = MemDC.SelectObject(&brush);

				CPen Pen(PS_SOLID, 3, RGB(0x80, 0x80, 0x80));
				CPen *pPenOld = MemDC.SelectObject(&Pen);

				int XEnd;
				int XStart = 0 - (DrawOffset % height);
				do {
					XEnd = XStart + height;

					MemDC.MoveTo(XStart - 1, height - 1);
					MemDC.LineTo(XStart - 1, -1);
					MemDC.MoveTo(XStart - 10, - 10);
					MemDC.LineTo(XEnd + 10, height + 10);	// +delta so that round endpoint is not seen

					MemDC.MoveTo(XEnd - 1, height - 1);
					MemDC.LineTo(XEnd - 1, 0);
					XStart += height;
				} while (XStart < Size);

				MemDC.SelectObject(pPenOld);

				CPen PenThin(PS_SOLID, 1, RGB(0, 0, 0));
				pPenOld = MemDC.SelectObject(&PenThin);

				MemDC.MoveTo(0, 10);
				MemDC.LineTo(Size, 10);

				MemDC.MoveTo(0, 15);
				MemDC.LineTo(Size, 15);

				MemDC.SelectObject(pPenOld);

				LOGFONT logFont;
				logFont.lfHeight = TEXT_HEIGHT_HS;
				logFont.lfWidth = 0; 
				logFont.lfEscapement = 0; 
				logFont.lfOrientation = 0; 
				logFont.lfWeight = FW_BOLD; 
				logFont.lfItalic = FALSE; 
				logFont.lfUnderline = FALSE; 
				logFont.lfStrikeOut = FALSE; 
				logFont.lfCharSet = DEFAULT_CHARSET;
				logFont.lfOutPrecision = OUT_DEFAULT_PRECIS; 
				logFont.lfClipPrecision = CLIP_DEFAULT_PRECIS; 
				logFont.lfQuality = DEFAULT_QUALITY; 
				logFont.lfPitchAndFamily = DEFAULT_PITCH; 
				strcpy(logFont.lfFaceName, "Times New Roman");

				MemDC.SetBkMode(TRANSPARENT);
				MemDC.SetTextColor(RGB(0, 128, 0));

				CFont font;
				if (font.CreateFontIndirect(&logFont) != 0) {
					CFont *pOldFont = MemDC.SelectObject(&font);

					RECT rect;
					char TextBuffer[50];
					rect.top = 0;
					rect.bottom = 100;
					int x = -1*(DrawOffset % (TEXT_SPACE_HS));  
					Count = DrawOffset/(TEXT_SPACE_HS);
					do {
						rect.left = x;
						rect.right = x + TEXT_SPACE_HS;
						sprintf(TextBuffer, "%4d", Count++);
						MemDC.DrawText(TextBuffer, -1, &rect, DT_LEFT | DT_SINGLELINE | DT_NOCLIP);
						x += TEXT_SPACE_HS;
					} while (rect.right < Size);

					MemDC.SelectObject(pOldFont);
				}
				
				MemDC.SelectObject(pBrushOld);
				MemDC.SelectObject(pBmpOld);
			}

			LPBITMAPINFO pDIBHdr;
			BYTE *pDIBBits; 

			BITMAP bm;
					// Get bitmap dimensions
		    GetObject(Bmp, sizeof(bm), (LPSTR)&bm);

			HDIB hDib = DibFromBitmap((HBITMAP)Bmp, BI_RGB, 32, NULL);
			if (hDib != NULL) {
			    pDIBHdr = (LPBITMAPINFO)GlobalLock(hDib);
				pDIBBits = (BYTE*)FindDIBBits((char*)pDIBHdr);

				width *= 4;
				DWORD PixColor;
				for (y = 0; y < (int)height; y++) {
					DWORD SrcRowOffset = (height - y - 1)*bm.bmWidth*4;
					DWORD DestRowOffset = y*Stride;
					for (x = 0; x < (int)width; x += 4) {
						PixColor = *(DWORD*)((DWORD)pDIBBits + SrcRowOffset + x);
						*(DWORD*)((DWORD)lpSurface + DestRowOffset + BufferOffset*4 + x) = PixColor | AlphaValue;
					}
				}
				GlobalUnlock(hDib);
				GlobalFree(hDib);
			}
		}
		ReleaseDC(NULL, DC.Detach());

		lpDDS->Unlock(NULL);
	}
}


void DrawOverlayBitmapHorz(int DrawOffset, int BufferOffset, int Size,
		LPDIRECTDRAWSURFACE lpDDS, int height, SCROLL_DIB_INFO* pScrollDibInfo,
		CGraphicsContent* pGraphicsContent)
{
	int x, y;
	DDSURFACEDESC SurfaceDesc;
	DWORD AlphaValue;
	DWORD AlphaMask;

	if (pGraphicsContent->m_AlphaSource == ALPHA_SRC_GENERATE) {
		AlphaValue = pGraphicsContent->m_StartingAlpha << 24;
		AlphaMask = 0xff000000;
	} else {
		AlphaValue = 0;
		AlphaMask = 0x00000000;
	}

	if (lpDDS->Lock(NULL, &SurfaceDesc, 0, NULL) == DD_OK) {

		DWORD width = Size;			
		DWORD Stride = SurfaceDesc.lPitch;
		DWORD BytesPerPixel = SurfaceDesc.ddpfPixelFormat.dwRGBBitCount/8;	// only 16 & 32 supported
		LPVOID lpSurface = SurfaceDesc.lpSurface;

		if (pScrollDibInfo->hDib != NULL) {
			width *= 4;
			DWORD PixColor;

			DWORD DibOffset = DrawOffset % pScrollDibInfo->dwWidth;

			for (y = 0; y < (int)height; y++) {
				int DibRow = (pScrollDibInfo->dwHeight - y - 1);
				if (DibRow < 0) {
					DibRow += pScrollDibInfo->dwHeight;
				}

				DWORD SrcRowOffset = (DWORD)DibRow*pScrollDibInfo->BytesPerRow;
				DWORD DestRowOffset = y*Stride;

				DWORD xs;
				for (x = 0, xs = DibOffset*pScrollDibInfo->BytesPerPixel; x < (int)width; x += 4, xs += pScrollDibInfo->BytesPerPixel) {

					if (xs >= pScrollDibInfo->dwWidth*pScrollDibInfo->BytesPerPixel) {
						xs = 0;
					}

					if (pScrollDibInfo->BytesPerPixel == 4) {
						PixColor = *(DWORD*)((DWORD)pScrollDibInfo->pDIBBits + SrcRowOffset + xs);
					} else if (pScrollDibInfo->BytesPerPixel == 3) {
						PixColor = ((DWORD)*(pScrollDibInfo->pDIBBits + SrcRowOffset + xs)) |
							(((DWORD)*(pScrollDibInfo->pDIBBits + SrcRowOffset + xs + 1)) << 8) |
							(((DWORD)*(pScrollDibInfo->pDIBBits + SrcRowOffset + xs + 2)) << 16);
					} else {				// Not supported
						PixColor = 0;		
					}

					PixColor &= ~AlphaMask;

					*(DWORD*)((DWORD)lpSurface + DestRowOffset + BufferOffset*4 + x) = PixColor | AlphaValue;
				}
			}
		}

		lpDDS->Unlock(NULL);
	}
}



UINT HorzScrollThread(LPVOID lpvParam)
{
	HRESULT result;
	RECT SrcRect;
	RECT DestRect;
	BOOL bUpdate = FALSE;
	int StopPoint = 0;
	POINT FilterStart;
	SIZE FilterSize;
	BOOL bFinished;
	DWORD Line;
	int DbgNotReadyCount;			// Debug only

	CCardDlg *pCCardDlg = (CCardDlg*)lpvParam;	
	CGraphicsContent content = pCCardDlg->pHScrollOvly->m_Content;

	CoInitialize(NULL);

	int error = 0;
	int WakeCnt = 0;
	int Offset = 0;
	int BufferPosition = 0;
	int FillSize = SRC_WIDTH_HS;
	int NextUpdatePosition = 0;
	pCCardDlg->HorzDisplayCount = 0; 

	if (content.m_Source == SRC_BMP_FILE) {
		DrawOverlayBitmapHorz(Offset, BufferPosition, FillSize, pCCardDlg->lpDDSOverlayHScroll, pCCardDlg->pHScrollOvly->m_Size.cy, &pCCardDlg->m_HScrollDibInfo, &content);
	} else {
		DrawOverlayHorz(pCCardDlg->HorzDisplayCount, Offset, BufferPosition, FillSize, pCCardDlg->lpDDSOverlayHScroll, pCCardDlg->pHScrollOvly->m_Size.cy);
	}
	Offset += FillSize;

	LPTULSASURFACEEXT lpTulsaSurfaceExt;

	result = CoCreateInstance(CLSID_STBTDDExtension, NULL, 
		CLSCTX_INPROC, IID_ISTBTDDSurfaceExt, (LPVOID *)&lpTulsaSurfaceExt);

	if (result != DD_OK) {
		pCCardDlg->lpDDSOverlayHScroll->Release();
		pCCardDlg->lpDDSOverlayHScroll = NULL;

		pCCardDlg->bHorzScrollThreadFinished = TRUE;

		CoUninitialize();
		return(0);
	}

	pCCardDlg->hEventHorzFF = CreateEvent(NULL, FALSE, FALSE, NULL);

										// Assign surface being extended
	lpTulsaSurfaceExt->AssignSurface(pCCardDlg->lpDDSOverlayHScroll);

	if (pCCardDlg->pHScrollOvly->m_bFilter) {
		FilterStart.x = 0;
		FilterStart.y = 0;
		FilterSize.cx = SRC_WIDTH_HS;
		FilterSize.cy = pCCardDlg->pHScrollOvly->m_Size.cy - 1; 
		ResetEvent(pCCardDlg->hEventHorzFF);

		if (lpTulsaSurfaceExt->StartFlickerFilter(&FilterStart, &FilterSize, pCCardDlg->hEventHorzFF) != DD_OK) {
			error++;
		}

		do {
			WaitForSingleObject(pCCardDlg->hEventHorzFF, INFINITE /*100*/);
			lpTulsaSurfaceExt->GetFlickerFilterStatus(&bFinished, &Line);
		} while (!bFinished && pCCardDlg->bEnableHorzScrollThread);
	}

	SrcRect.left = 0;
	SrcRect.top = 0;
	SrcRect.right = SrcRect.left + SRC_WIDTH_HS - 1;
	SrcRect.bottom = SrcRect.top + pCCardDlg->pHScrollOvly->m_Size.cy; 
	DestRect.left = pCCardDlg->pHScrollOvly->m_Position.x;
	DestRect.top = pCCardDlg->pHScrollOvly->m_Position.y;
	DestRect.right = DestRect.left + pCCardDlg->pHScrollOvly->m_Size.cx - 1;
	DestRect.bottom = DestRect.top + pCCardDlg->pHScrollOvly->m_Size.cy - 1;

	pCCardDlg->hEventHorzScroll = CreateEvent(NULL, FALSE, FALSE, NULL);

	SURFACEDESCEXT SurfaceDescExt;
	INIT_DIRECTDRAW_STRUCT(SurfaceDescExt);
	SurfaceDescExt.dwFlags = SDE_SCROLL_HORZ | SDE_SCROLL_SET_SRC_POS;

	SurfaceDescExt.lScrollPixelsPerStep = pCCardDlg->pHScrollOvly->m_PixelsPerStep;
	SurfaceDescExt.dwScrollVerticalsPerStep = pCCardDlg->pHScrollOvly->m_VerticalsPerStep;
	SurfaceDescExt.dwScrollPausePosition = SRC_WIDTH_HS - pCCardDlg->pHScrollOvly->m_Size.cx;
	SurfaceDescExt.dwScrollPosition = 0;

#ifdef TEST_ABS_NOTIF
	SurfaceDescExt.dwScrollNotifPosition = SurfaceDescExt.dwScrollPausePosition - 10;
	if (SurfaceDescExt.dwScrollNotifPosition < 0) {
		SurfaceDescExt.dwScrollNotifPosition += SRC_WIDTH_HS;
	}
	SurfaceDescExt.dwScrollNotifIncrement = 0xffffffff;
#else

	if (SurfaceDescExt.lScrollPixelsPerStep > 0) {
		SurfaceDescExt.dwScrollNotifIncrement = (SRC_WIDTH_HS - UPDATE_SIZE_HS - pCCardDlg->pHScrollOvly->m_Size.cx)/(2*SurfaceDescExt.lScrollPixelsPerStep);
		if (SurfaceDescExt.dwScrollNotifIncrement == 0) {
			SurfaceDescExt.dwScrollNotifIncrement = 1;
		}
	} else {
		SurfaceDescExt.dwScrollNotifIncrement = 0xffffffff;
	}

	SurfaceDescExt.dwFlags |= SDE_SCROLL_NOTIFY_RESET;

	SurfaceDescExt.dwScrollNotifPosition = 0xffffffff;
#endif
	SurfaceDescExt.hScrollEvent = pCCardDlg->hEventHorzScroll;
	SurfaceDescExt.bPreserveDestAlpha = !pCCardDlg->pHScrollOvly->m_bWriteAlpha;
	lpTulsaSurfaceExt->SetSurfaceDescExt(&SurfaceDescExt);
			
	if (pCCardDlg->HScrollZOrderFlags) {
		pCCardDlg->lpDDSOverlayHScroll->UpdateOverlayZOrder(pCCardDlg->HScrollZOrderFlags & 0xfffffff, NULL);
		pCCardDlg->HScrollZOrderFlags = 0;
	}

	pCCardDlg->lpDDSOverlayHScroll->UpdateOverlay(&SrcRect, pCCardDlg->lpDDSPrimaryRGB, 
		&DestRect, DDOVER_SHOW | (pCCardDlg->pHScrollOvly->m_bBlend? DDOVER_ALPHASRC: 0) | 
		(pCCardDlg->pHScrollOvly->m_bInvBlend? DDOVER_ALPHASRCNEG: 0), NULL);

	int FirstDrawingPassSize;
	int SecondDrawingPassSize;

	pCCardDlg->HScrollReady = TRUE;

	while(pCCardDlg->bEnableHorzScrollThread) {
		lpTulsaSurfaceExt->GetSurfaceDescExt(&SurfaceDescExt);
		int PixelsAway = SurfaceDescExt.dwScrollPosition - NextUpdatePosition;
		if (PixelsAway < 0) {
			PixelsAway += SRC_WIDTH_HS;
		}
		if (PixelsAway >= UPDATE_SIZE_HS) {
			int LastUpdatePos = NextUpdatePosition + UPDATE_SIZE_HS - 1;
			if (LastUpdatePos >= SRC_WIDTH_HS) {
				SecondDrawingPassSize = LastUpdatePos - SRC_WIDTH_HS;
				FirstDrawingPassSize = SRC_WIDTH_HS - NextUpdatePosition;
			} else {
				SecondDrawingPassSize = 0;
				FirstDrawingPassSize = UPDATE_SIZE_HS;
			}

			if (content.m_Source == SRC_BMP_FILE) {
				DrawOverlayBitmapHorz(Offset, 
					NextUpdatePosition, FirstDrawingPassSize, pCCardDlg->lpDDSOverlayHScroll,
					pCCardDlg->pHScrollOvly->m_Size.cy,	&pCCardDlg->m_HScrollDibInfo, &content);
			} else {
				DrawOverlayHorz(pCCardDlg->HorzDisplayCount, Offset, 
					NextUpdatePosition, FirstDrawingPassSize, pCCardDlg->lpDDSOverlayHScroll,
					pCCardDlg->pHScrollOvly->m_Size.cy);
			}

			if (pCCardDlg->pHScrollOvly->m_bFilter) {
				FilterStart.x = NextUpdatePosition;
				FilterSize.cx = FirstDrawingPassSize;
				ResetEvent(pCCardDlg->hEventHorzFF);
				if (lpTulsaSurfaceExt->StartFlickerFilter(&FilterStart, &FilterSize, pCCardDlg->hEventHorzFF) != DD_OK) {
					error++;
				}
				do {
					WaitForSingleObject(pCCardDlg->hEventHorzFF, INFINITE /*100*/);
					lpTulsaSurfaceExt->GetFlickerFilterStatus(&bFinished, &Line);
				} while (!bFinished && pCCardDlg->bEnableHorzScrollThread);
			}

			NextUpdatePosition += FirstDrawingPassSize;
			if (NextUpdatePosition >= SRC_WIDTH_HS) {
				NextUpdatePosition = 0;
			}
			Offset += FirstDrawingPassSize;

			if (SecondDrawingPassSize > 0) {
				if (content.m_Source == SRC_BMP_FILE) {
					DrawOverlayBitmapHorz(Offset, 
						NextUpdatePosition, SecondDrawingPassSize, pCCardDlg->lpDDSOverlayHScroll,
						pCCardDlg->pHScrollOvly->m_Size.cy, &pCCardDlg->m_HScrollDibInfo, &content);
				} else {
					DrawOverlayHorz(pCCardDlg->HorzDisplayCount, Offset, 
						NextUpdatePosition, SecondDrawingPassSize, pCCardDlg->lpDDSOverlayHScroll,
						pCCardDlg->pHScrollOvly->m_Size.cy);
				}

				if (pCCardDlg->pHScrollOvly->m_bFilter) {
					FilterStart.x = NextUpdatePosition;
					FilterSize.cx = SecondDrawingPassSize;
					ResetEvent(pCCardDlg->hEventHorzFF);
					if (lpTulsaSurfaceExt->StartFlickerFilter(&FilterStart, &FilterSize, pCCardDlg->hEventHorzFF) != DD_OK) {
						error++;
					}
					do {
						WaitForSingleObject(pCCardDlg->hEventHorzFF, INFINITE /*100*/);
						lpTulsaSurfaceExt->GetFlickerFilterStatus(&bFinished, &Line);
					} while (!bFinished && pCCardDlg->bEnableHorzScrollThread);
				}

				NextUpdatePosition += SecondDrawingPassSize;
				Offset += SecondDrawingPassSize;
			}

			StopPoint = NextUpdatePosition - pCCardDlg->pHScrollOvly->m_Size.cx;
			if (StopPoint < 0) {
				StopPoint += SRC_WIDTH_HS;
			}

			bUpdate = TRUE;

		} else if (pCCardDlg->m_bHSUpdate) {
			pCCardDlg->m_bHSUpdate = FALSE;
			bUpdate = TRUE;
		} else {
			DbgNotReadyCount++;					// Debug
		}


		if (bUpdate) {
			DbgNotReadyCount = 0;				// Debug

			bUpdate = FALSE;
			SurfaceDescExt.dwFlags = SDE_SCROLL_HORZ;
			SurfaceDescExt.lScrollPixelsPerStep = pCCardDlg->pHScrollOvly->m_PixelsPerStep;
			SurfaceDescExt.dwScrollVerticalsPerStep = pCCardDlg->pHScrollOvly->m_VerticalsPerStep;
			SurfaceDescExt.dwScrollPausePosition = StopPoint;
			SurfaceDescExt.dwScrollPosition = 0;
#ifdef TEST_ABS_NOTIF
			SurfaceDescExt.dwScrollNotifPosition = SurfaceDescExt.dwScrollPausePosition - 10;
			if (SurfaceDescExt.dwScrollNotifPosition < 0) {
				SurfaceDescExt.dwScrollNotifPosition += SRC_WIDTH_HS;
			}
			SurfaceDescExt.dwScrollNotifIncrement = 0xffffffff;
#else

			if (SurfaceDescExt.lScrollPixelsPerStep > 0) {
				SurfaceDescExt.dwScrollNotifIncrement = (SRC_WIDTH_HS - UPDATE_SIZE_HS - pCCardDlg->pHScrollOvly->m_Size.cx)/(2*SurfaceDescExt.lScrollPixelsPerStep);
				if (SurfaceDescExt.dwScrollNotifIncrement == 0) {
					SurfaceDescExt.dwScrollNotifIncrement = 1;
				}
			} else {
				SurfaceDescExt.dwScrollNotifIncrement = 0xffffffff;
			}

			SurfaceDescExt.dwFlags |= SDE_SCROLL_NOTIFY_RESET;

			SurfaceDescExt.dwScrollNotifPosition = 0xffffffff;
#endif
			SurfaceDescExt.hScrollEvent = pCCardDlg->hEventHorzScroll;
			SurfaceDescExt.bPreserveDestAlpha = !pCCardDlg->pHScrollOvly->m_bWriteAlpha;
			lpTulsaSurfaceExt->SetSurfaceDescExt(&SurfaceDescExt);

			DestRect.left = pCCardDlg->pHScrollOvly->m_Position.x;
			DestRect.top = pCCardDlg->pHScrollOvly->m_Position.y;
			DestRect.right = DestRect.left + pCCardDlg->pHScrollOvly->m_Size.cx - 1;
			DestRect.bottom = DestRect.top + pCCardDlg->pHScrollOvly->m_Size.cy - 1;

			pCCardDlg->lpDDSOverlayHScroll->UpdateOverlay(&SrcRect, pCCardDlg->lpDDSPrimaryRGB, &DestRect, 
				DDOVER_SHOW | (pCCardDlg->pHScrollOvly->m_bBlend? DDOVER_ALPHASRC: 0) | 
				(pCCardDlg->pHScrollOvly->m_bInvBlend? DDOVER_ALPHASRCNEG: 0), NULL);

			if (pCCardDlg->HScrollZOrderFlags) {
				pCCardDlg->lpDDSOverlayHScroll->UpdateOverlayZOrder(pCCardDlg->HScrollZOrderFlags & 0xfffffff, NULL);
				pCCardDlg->HScrollZOrderFlags = 0;
			}
		}

		WaitForSingleObject(pCCardDlg->hEventHorzScroll, INFINITE);
		ResetEvent(pCCardDlg->hEventHorzScroll);
		WakeCnt++;
	}

	SurfaceDescExt.hScrollEvent = NULL;
	lpTulsaSurfaceExt->SetSurfaceDescExt(&SurfaceDescExt);

	pCCardDlg->lpDDSOverlayHScroll->UpdateOverlay(&SrcRect, pCCardDlg->lpDDSPrimaryRGB, &DestRect, 
		DDOVER_SHOW, NULL);

	HANDLE hEventTemp = pCCardDlg->hEventHorzScroll;
	pCCardDlg->hEventHorzScroll = NULL;
	CloseHandle(hEventTemp);

	hEventTemp = pCCardDlg->hEventHorzFF;
	pCCardDlg->hEventHorzFF = NULL;
	CloseHandle(hEventTemp);

	lpTulsaSurfaceExt->Release();
	lpTulsaSurfaceExt = NULL;

	pCCardDlg->lpDDSOverlayHScroll->Release();
	pCCardDlg->lpDDSOverlayHScroll = NULL;

	pCCardDlg->bHorzScrollThreadFinished = TRUE;

	CoUninitialize();

	return(0);
}


void CCardDlg::StartHorzScrollTest(void)
{
	HRESULT ddrval;
	DDSURFACEDESC   ddsd;
    INIT_DIRECTDRAW_STRUCT(ddsd);

	if (bEnableHorzScrollThread) {				
		return;							// Already enabled
	}

	if (pHScrollOvly->m_Content.m_Source == SRC_BMP_FILE) {
		ReadScrollBitmap(pHScrollOvly->m_Content.m_Filename, m_HScrollDibInfo);
	}

	HScrollReady = FALSE;

	ddsd.dwHeight = pHScrollOvly->m_Size.cy;
	ddsd.dwWidth = SRC_WIDTH_HS;
	ddsd.ddpfPixelFormat.dwSize = sizeof(DDPIXELFORMAT);
	ddsd.ddpfPixelFormat.dwFlags = DDPF_RGB;
	ddsd.ddpfPixelFormat.dwRGBBitCount = 32;
    ddsd.dwFlags = DDSD_CAPS | DDSD_WIDTH | DDSD_HEIGHT | DDSD_PIXELFORMAT;
    ddsd.ddsCaps.dwCaps = DDSCAPS_OVERLAY;
										// Create an overlay surface for graphics
	ddrval = lpDD2RGB->CreateSurface(&ddsd, &lpDDSOverlayHScroll, NULL);
	if (ddrval == DD_OK) {
										// Copy bitmap onto surface and display
										//  with no blending or colorkeying
		DDSURFACEDESC SurfaceDesc;
		if (lpDDSOverlayHScroll->Lock(NULL, &SurfaceDesc, 0, NULL) == DD_OK) {
			lpDDSOverlayHScroll->Unlock(NULL);
		}

		bEnableHorzScrollThread = TRUE;
		bHorzScrollThreadFinished = FALSE;
		AfxBeginThread(HorzScrollThread, (LPVOID)this, THREAD_PRIORITY_NORMAL);

										// Wait for scrolling to paint and flicker filter
										//  initial screen area
		while (!HScrollReady) {
			Sleep(10);
		}

	} else {
		FreeScrollBitmap(m_HScrollDibInfo);
		AfxMessageBox("Could not create overlay surface for horizontal scrolling surface");
	}
}


void CCardDlg::StopHorzScrollTest(void)
{
	if (bEnableHorzScrollThread) {
		bEnableHorzScrollThread = FALSE;

		if (hEventHorzScroll) {
			SetEvent(hEventHorzScroll);
		}
		if (hEventHorzFF) {
			SetEvent(hEventHorzFF);
		}

		for (int i = 0; /*i < 200 &&*/ !bHorzScrollThreadFinished; i++) {
			Sleep(50);
		}
		
		if (!bHorzScrollThreadFinished) {
			Sleep(50);
		}
		FreeScrollBitmap(m_HScrollDibInfo);
	}
}

void CCardDlg::UpdateHorzScrollTest(void)
{
	if (bEnableHorzScrollThread) {
		m_bHSUpdate = TRUE;
		if (hEventHorzScroll) {
			SetEvent(hEventHorzScroll);
		}
	}
}

BOOL CCardDlg::HorzScrollEnabled(void)
{
	return(bEnableHorzScrollThread);
}



